{% extends "base.html" %} {% block title %}
<title>消息中心 -- {{ receiver }}</title>
{% endblock %} {% block css %} {{ super() }} {% endblock %} {% block header %} {{ super() }} {% endblock %} {% block main %}
<!-- main-area -->
<main>
    <div class="checkout-area pt-90 pb-90">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-lg-4">
                    <div class="shop-cart-total order-summary-wrap" id="meet_list">
                        <h3 class="title">我的消息</h3>
                    </div>
                </div>
                <div class="col-lg-8">
                    <div class="checkout-form-wrap" id="textbox">
                        <form action="javascript:void(0)">
                            {% if receiver=="80000000" %}
                            <h4 style="color: #c00000">系统通知</h4>
                            {% else %}
                            <h4>{{ receiver }}</h4>
                            {% endif %}

                            <div class="contact-info-wrap" id="chat" style="height: 300px; overflow: auto"></div>
                            <br /><br />
                            <div class="building-info-wrap"><input id="text" placeholder="回车发送消息..." /></br></br></div>

                            <div class="continue-shopping">
                                <form action="javascript:void(0)">
                                    <input type="file" id="file" style="display: none" onchange="uploadImg()" />
                                    <button href="javascript:void(0)" onclick="selectImg()" class="btn">上传图片</button>
                                </form>
                            </div>
                            <div>
                                <img src="" id="preview" style="height: 150px" />
                            </div>
                            <a href="#" onclick="leave_room();">Leave this room</a>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</main>
<!-- main-area-end -->
{% endblock %} {% block footer %} {{ super() }} {% endblock %} {% block js %} {{ super() }}
<script type="text/javascript" src="//cdn.socket.io/4.4.1/socket.io.min.js"></script>
<script type="text/javascript" charset="utf-8">
    var socket;
    var room = "{{ room|safe }}";
    var sender = "{{ sender|safe }}";
    var receiver = "{{ receiver|safe }}";

    $(document).ready(function () {
        if (sender != "" && sender == receiver) {
            suspend("alert-danger","不能给自己发消息哦~ ");
            sleep(500).then(() => {window.location.href = "{{ url_for('chat.index') }}";});
            
        }
        if (room == "") {
            $("#textbox").after("<h4>您还未选中聊天室</h4>");
            $("#textbox").hide();
        }

        socket = io.connect(location.protocol +"//"+ document.domain + ":" + location.port + "/chat",
        {"transports":["websocket"]});
        //socket = io.connect("wss://market.ellye.cn/chat",{"force new connection":true});

        //console.log(document.domain,location.port)
        let conn=0;
        socket.on("connect", function () {
            if (conn==0)
            {
                let cur_time = new Date(new Date().getTime()).toLocaleString();
                socket.emit("joined", { time: cur_time, room: room, receiver: receiver});
                console.log(sender);
                conn=1;
            }
            else
                socket.emit("reconnect", { room: room, receiver: receiver});
        });
        socket.on("message", function (data) {
            let sender = data.sender;
            let name = data.other_user;
            let sname = name;
            let color = "#516583";
            if (data.sender == "80000000") {
                sname = "系统通知";
                sender = "系统通知";
                color = "#C00000";
            }
            let dmsg=""
            if (data.msg.length>50)
            {
                dmsg="</br>";
                let n = 30;
                let a="";
                for (let i = 0, l = data.msg.length; i < l/n; i++) {
                    a=data.msg.substring(i*n,(i+1)*n);
                    dmsg+=a+'</br>';
                }
            }
            else
            {
                dmsg+=data.msg+'</br>';
            }
            if (data.type == 0) {
                let str = `<span> ${data.time}</br>${sender}:${dmsg}</br></span>`;
                $("#chat").append(str);
            } else {
                let str = `
                <span> ${data.time}</br>${sender}:</br>
                    <a href='/chat/static/resource/temp/${room}/${data.msg}' onclick="OpenFullSizeWindow(this.href);return false">
                    <img style="width:100px" src='/chat/static/resource/temp/${room}/${data.msg}'/>
                </br>
                </span>`;
                $("#chat").append(str);
            }
            $("#chat").scrollTop($("#chat")[0].scrollHeight);
            let last_msg = data.msg;
            if (data.type == 1) last_msg = "[图片]";
            if(last_msg.length>10)last_msg=last_msg.substr(0,10)+"...";
            if (`#chat_${name}`.length > 0) $(`#chat_${name}`).html(last_msg);
            else {
                let str = `  
                        <div class="os-products-item">
                            <div class="thumb">
                                <a href="/user/${name}/user_info">
                                    <img src="/user/static/resource/user-pic/${name}/avatar_128.WEBP" alt="" /></a>
                            </div>
                            <div class="content">
                                <h6 class="title">
                                    <a href="/chat/${name}" style="color:${color}">${sname}</a>
                                </h6>
                                <span class="price" id="chat_${name}">${last_msg}</span>
                            </div>
                            <div class="remove">x</div>
                        </div>`;
                $("#meet_list").append(str);
            }
        });
        socket.on("notice",function(data){
            let sender = data.sender;
            let sname = sender;
            let color = "#516583";
            if (data.sender == "80000000") {
                sname = "系统通知";
                sender = "系统通知";
                color = "#C00000";
            }
            let last_msg = data.msg;
            if (data.type == 1) last_msg = "[图片]";
            if(last_msg.length>10)last_msg=last_msg.substr(0,10)+"...";
            if ($(`#meet_${sender}`).length==0)
            {
                let str = `  
                        <div class="os-products-item" id="meet_${sender}">
                            <div class="thumb">
                                <a href="/user/${sender}/user_info">
                                    <img src="/user/static/resource/user-pic/${sender}/avatar_128.WEBP" alt="" /></a>
                            </div>
                            <div class="content">
                                <h6 class="title">
                                    <a href="/chat/${sender}" style="color:${color}">${sname}</a>
                                </h6>
                                <span class="price" id="chat_${sender}">${last_msg}</span>
                            </div>
                            <div class="remove" onclick="deldiv(${sender})">x</div>
                        </div>`;
                        $("#meet_list").append(str);
            }
            else
            {
                $(`#chat_${sender}`).html(last_msg);
            }
        })
        $("#text").keypress(function (e) {
            var code = e.keyCode || e.which;
            let cur_time = new Date(new Date().getTime()).toLocaleString();
            if (code == 13) {
                text = $("#text").val();
                $("#text").val("");
                if (text != "") socket.emit("text", { msg: text, time: cur_time, receiver: receiver, room: room, type: 0 });
                return false;
            }
        });
        window.addEventListener("beforeunload", function (event) {
            // or 'unload'
            navigator.sendBeacon("/chat/close", room);
            // more safely (optional...?)
            var until = new Date().getTime() + 500;
            while (new Date().getTime() < until);
        });

        $.ajax({
            type: "GET",
            url: "/api/get_meet_list",
            success: function (ret) {
                if (ret.statusCode == 200) {
                    let meet_list = ret.data.meet_list;
                    let last_msg_dict = new Array(); //定义一个字典
                    $.ajax({
                        type: "GET",
                        async: false,
                        url: "/api/get_last_msg",
                        success: function (ret) {
                            if (ret.statusCode == 200) last_msg_dict = ret.data;
                            else suspend("alert-danger","获取最近消息失败: "+ret.message);
                        },
                    });
                    for (let i = 0; i < meet_list.length; i++) {
                        let name = meet_list[i];
                        let sname = name;
                        let color = "#516583";
                        if (name == "80000000") {
                            sname = "系统通知";
                            color = "#C00000";
                        }
                        let last_msg = last_msg_dict[name]["last_msg"];
                        if (last_msg_dict[name]["type"] == 1) last_msg = "[图片]";
                        if(last_msg.length>10)last_msg=last_msg.substr(0,10)+"...";
                        let str = `  
                        <div class="os-products-item" id="meet_${name}">
                            <div class="thumb">
                                <a href="/user/${name}/user_info">
                                    <img src="/user/static/resource/user-pic/${name}/avatar_128.WEBP" alt="" /></a>
                            </div>
                            <div class="content">
                                <h6 class="title">
                                    <a href="/chat/${name}" style="color:${color}">${sname}</a>
                                </h6>
                                <span class="price" id="chat_${name}">${last_msg}</span>
                            </div>
                            <div class="remove" onclick="deldiv(${name})">x</div>
                        </div>`;
                        $("#meet_list").append(str);
                    }
                } else suspend("alert-danger","获取聊天列表失败: "+ret.message);
            },
        });
    });

    function deldiv(name) {
        $(`#meet_${name}`).remove();
        $.ajax({
            type: "DELETE",
            url: "/api/del_meet",
            data: JSON.stringify({ user_id: name }),
            contentType: "application/json;charset=utf-8",
            processData: false,
            success: function (ret) {
                if (ret.statusCode == 200) {
                    suspend("alert-success", "删除聊天成功");
                    showUnreadNews();
                    if (receiver==name)
                        sleep(500).then(() => {window.location.href = "{{ url_for('chat.index') }}";});
                } else suspend("alert-danger","删除聊天失败: "+ret.message);
            },
        });
    }
    function OpenFullSizeWindow(url) {
        var newWindow = window.open("");
        newWindow.document.body.innerHTML = '<img style="height:600px" src="' + url + '" alt="">';
    }

    function selectImg() {
        $("#file").click(); // 相当于模拟点击一下选择图片按钮
    }
    function uploadImg() {
        var file = $("#file")[0].files[0];
        var filepath = $("#file")[0].value;
        let fileTypes = [".jpg", ".png", ".jpeg", ".PNG", ".gif"];
        if (file) {
            // console.log("开始上传图片：" + file.name);

            let isNext = false;
            let fileEnd = filepath.substring(filepath.indexOf(".")); //截取文件名的后缀
            for (var i = 0; i < fileTypes.length; i++) {
                if (fileTypes[i] == fileEnd) {
                    isNext = true;
                    break;
                }
            }
            if (!isNext) {
                suspend("alert-danger","不接受此文件类型");
                //alert("不接受此文件类型");
                $("#file").val(""); //如果文件后缀名不符合，清空已选择文件
                return false;
            }

            var formData = new FormData();
            formData.append("file", file);
            formData.append("room", room);
            formData.append("sender", sender);
            formData.append("receiver", receiver);
            var debug = 0;
            if (debug == 0) {
                $.ajax({
                    url: "/api/post_chat_pic",
                    type: "post",
                    data: formData,
                    contentType: false,
                    processData: false,
                    success: function (ret) {
                        if (ret.statusCode == 200) {
                            suspend("alert-success", ret.message);
                            md5 = ret.data;
                            $("#file").val("");
                            //updatePage(objUrl, md5);
                        } else suspend("alert-danger","上传聊天图片失败: "+ret.message);
                    },
                });
            } else {
                md5 = Math.random().toString(36).substr(2);
                //updatePage(objUrl, md5);
            }
        } else suspend("alert-danger","未选择图片！");
    }
    function leave_room() {
        socket.emit("left", { room: room }, function () {
            socket.disconnect();
            // go back to the index page
            window.location.href = "{{ url_for('user.index') }}";
        });
    }
</script>
{% endblock %}
